
;**************************** Allgemeine Routinen **************************

;*********************************************************************
;  Warte 5ms
;
;  Scratch-Reg: -
;*********************************************************************

wait_5ms:
        push    ZL
        push    ZH

        load_p  Z,5000*(CYCLES_PER_US/4)
		        ; 5 mS warten, 4 = Anzahl Befehls-Zyclen vom sbiw + brcc

d_loop:
        sbiw    ZL,1
        brne    d_loop

        pop     ZH
        pop     ZL

        ret

;*********************************************************************
;  Ldt 512 Byte Daten aus EEPROM an Ladeadresse, Ladeadresse nach Ende in PC_L,PC_H (Y)
;
;  Scratch-Reg: -
;*********************************************************************

load_sid:
		load_p	Y,0						; EEPROM-Start

        out     EEARL,YL	
        out     EEARH,YH   				; H-Byte Adresse
 		sbi     EECR,EERE               ; Lesen
        in      TEMP_A,EEDR             ; Daten holen
		mov		ZL,TEMP_A				; Low Ladeadresse
		adiw	Y,1


        out     EEARL,YL	
        out     EEARH,YH   				; H-Byte Adresse
 		sbi     EECR,EERE               ; Lesen
        in      TEMP_A,EEDR             ; Daten holen
		mov		ZH,TEMP_A				; High Ladeadresse
		adiw	Y,1

		ldi		ZL,$D9
		ldi		ZH,$08
		push	ZH						; merken
		push	ZL

		ldi		TEMP_B,254				; -2 Byte Ladeadresse

load_sid_loop_1:
        out     EEARL,YL	
        out     EEARH,YH   				; H-Byte Adresse
 		sbi     EECR,EERE               ; Lesen
        in      TEMP_A,EEDR             ; Daten holen
		st		Z+,TEMP_A				; im externen Ram speichern
		adiw	Y,1

		dec     TEMP_B                  ; erste 256 Byte fertig?
        brne    load_sid_loop_1

load_sid_loop_2:
        out     EEARL,YL	
        out     EEARH,YH   				; H-Byte Adresse
 		sbi     EECR,EERE               ; Lesen
        in      TEMP_A,EEDR             ; Daten holen
		st		Z+,TEMP_A				; im externen Ram speichern
		adiw	Y,1

		dec     TEMP_B                  ; zweite 256 Byte fertig?
        brne    load_sid_loop_2

		pop		YL						; Ladeadresse in Y (PC 6510)
		pop		YH

		ret
